package com.iformall.controller.msg;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.WxMsgModel;
import com.iformall.service.WxMsgModelService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxMsgModel")
public class WxMsgModelController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMsgModelService wxMsgModelService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "短信模板-列表")
    public ResultData list(@ModelAttribute WxMsgModel wxMsgModel, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMsgModelController::list");
        if (null == wxMsgModel) wxMsgModel = new WxMsgModel();
        wxMsgModel.setTenantId(getTenantId());
        wxMsgModel.setSortColumns(BaseEntity.SortField.Createtime_DESC);
        final PageInfo<WxMsgModel> page = wxMsgModelService.listAsPage(wxMsgModel, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "短信模板-新增")
    public ResultData add(@RequestBody WxMsgModel wxMsgModel) {
        logger.debug("[" + getIpAddr() + "] WxMsgModelController::add");
        //Assert.notNull(wxMsgModel.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxMsgModel.setTenantId(getTenantId());
        return wxMsgModelService.saveOrUpdate(wxMsgModel);

    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "短信模板-更新")
    public ResultData update(@RequestBody WxMsgModel wxMsgModel) {
        logger.debug("[" + getIpAddr() + "] WxMsgModelController::update");
        return wxMsgModelService.saveOrUpdate(wxMsgModel);
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "短信模板-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgModelController::delete");
        wxMsgModelService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "短信模板-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgModelController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMsgModelService.getById(id));
    }

    @ApiOperation("获取所有数据")
    @GetMapping("getmodellist")
    @SystemControllerLog(description = "短信模板-获取所有数据")
    public ResultData getmodellist() {
        logger.debug("[" + getIpAddr() + "] WxMsgModelController::getmodellist");
        return wxMsgModelService.getmodellist(getTenantId());
    }


}
